Skip to main content

Integration with Angular

tip

You should be familiar with the basic concepts and patterns of Angular to use this documentation. If you are not, please refer to the Angular documentation for a getting-started tutorial.

DHTMLX Spreadsheet is compatible with Angular. We have prepared code examples of how to use DHTMLX Spreadsheet with Angular. To check online samples, please refer to the corresponding Example on Replit.

You can also check the demo on GitHub.

Creating a project

info

Before you start to create a new project, install Angular CLI and Node.js.

Create a new my-angular-spreadsheet-app project using Angular CLI. Run the following command for this purpose:

ng new my-angular-spreadsheet-app

The above command will install all the necessary tools and dependencies, so you don't need any additional commands.

Installation of dependencies

After that, go to the app directory:

cd my-angular-spreadsheet-app

Then, run the app with the following command:

yarn start

After that, the app should run on http://localhost:4200.

Angular app running

Creating Spreadsheet

Now we should get the DHTMLX Spreadsheet code. First of all, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Spreadsheet package.

Step 1. Package installation

Download the trial Spreadsheet package and follow the steps mentioned in the README file. Note that the trial Spreadsheet is available 30 days only.

Check the How to Start guide to learn about the available installation ways.

Step 2. Component creation

Now we should create a component, to add a Spreadsheet into the application. Let's create the spreadsheet folder in the src/app/ directory, add a new file into it and call it spreadsheet.component.ts. Then complete the steps described below.

Importing source files

Open the file and import Spreadsheet source files. Note that:

  • if you've installed the Spreadsheet package from a local folder, your import paths will look like this:
import { Spreadsheet } from 'dhx-spreadsheet-package';
import 'dhx-spreadsheet-package/codebase/spreadsheet.css';

Note that depending on the used package, the source files can be minified. In this case make sure that you are importing the CSS file as spreadsheet.min.css.

  • if you've chosen to install the trial version], the import paths should be as in:
import { Spreadsheet } from '@dhx/trial-spreadsheet';
import '@dhx/trial-spreadsheet/codebase/spreadsheet.min.css';

In this tutorial we will use the trial version of Spreadsheet.

Setting the container and adding Spreadsheet

To display Spreadsheet on the page, we need to set the container to render the component inside. Use the code below:

spreadsheet.component.ts
import { Spreadsheet } from '@dhx/trial-spreadsheet';
import '@dhx/trial-spreadsheet/codebase/spreadsheet.min.css';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy} from '@angular/core';

@Component({
selector: 'spreadsheet',
template: '<div style={{height: '80vh'}} #spreadsheetContainer></div>',
})
export class SpreadsheetComponent implements OnInit {
@ViewChild('spreadsheetContainer', { static: true }) spreadsheetContainer!: ElementRef;

private spreadsheet!: Spreadsheet;
}

Then we need to render our Spreadsheet in the container. To do that, use the ngOnInit() method of Angular:

spreadsheet.component.ts
export class SpreadsheetComponent implements OnInit, OnDestroy {
@ViewChild('spreadsheetContainer', { static: true }) spreadsheetContainer!: ElementRef;

private spreadsheet!: Spreadsheet;

ngOnInit() {
this.spreadsheet = new Spreadsheet(this.spreadsheetContainer.nativeElement,{});
}

ngOnDestroy() {
this.spreadsheet?.destructor();
}
}

In the above code we've also specified the ngOnDestroy() method that contains the spreadsheet.destructor() call to clear the component when it is no longer needed.

Loading data

To add data into the Spreadsheet, we need to provide a data set. Let's create the data.ts file in the src/app/spreadsheet/ directory and add some data into it:

data.ts
export function getData(): any {
return {
styles: {
bold: {
"font-weight": "bold",
},
right: {
"justify-content": "flex-end",
"text-align": "right",
},
},
data: [
{ cell: "a1", value: "Country", css:"bold" },
{ cell: "b1", value: "Product", css:"bold" },
{ cell: "c1", value: "Price", css:"right bold" },
{ cell: "d1", value: "Amount", css:"right bold" },
{ cell: "e1", value: "Total Price", css:"right bold" },

{ cell: "a2", value: "Ecuador" },
{ cell: "b2", value: "Banana" },
{ cell: "c2", value: 6.68, format: "currency" },
{ cell: "d2", value: 430 },
{ cell: "e2", value: 2872.4, format: "currency" },

{ cell: "a3", value: "Belarus" },
{ cell: "b3", value: "Apple" },
{ cell: "c3", value: 3.75, format: "currency" },
{ cell: "d3", value: 600 },
{ cell: "e3", value: 2250, format: "currency" },

{ cell: "a4", value: "Peru" },
{ cell: "b4", value: "Grapes" },
{ cell: "c4", value: 7.69, format: "currency" },
{ cell: "d4", value: 740 },
{ cell: "e4", value: 5690.6, format: "currency" },

// more cells with data
],
};
}

Then open the spreadsheet.component.ts file. Import the file with data and add the spreadsheet.parse(); call into the ngOnInit() method, as shown below. It will reload data on each applied change.

spreadsheet.component.ts
// importing the data file
import { getData } from './data';

ngOnInit() {
this.spreadsheet = new Spreadsheet(this.spreadsheetContainer.nativeElement,{});
// adding spreadsheet.parse() into `ngOnInit()`
this.spreadsheet.parse(getData());
}

Now the Spreadsheet component is ready. When the element will be added to the page, it will initialize the Spreadsheet object with data. You can provide necessary configuration settings as well. Visit our Spreadsheet API docs to check the full list of available properties.

Handling events

When a user makes some action in the Spreadsheet, it invokes an event. You can use these events to detect the action and run the desired code for it. See the full list of events.

Open the spreadsheet.component.ts file and complete the ngOnInit() method as in:

spreadsheet.component.ts
ngOnInit() {
this.spreadsheet = new Spreadsheet(this.spreadsheetContainer.nativeElement,{});

this.spreadsheet.parse(getData());
this.spreadsheet.events.on('ActionName', () => {
// do something
});
}

Replace 'ActionName' with the actual name of the event you want to handle, and implement the corresponding code inside the callback function. Get more information about the work with events in the Event Handling article.

Step 3. Adding Spreadsheet into the app

Now it's time to add the component into our app. Open src/app/app.component.ts and use SpreadsheetComponent instead of the default content by inserting the code below:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<spreadsheet></spreadsheet>`,
})
export class AppComponent {
name = "";
}

Then create the app.module.ts file in the src/app/ directory and insert the SpreadsheetComponent as provided below:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { SpreadsheetComponent } from "./spreadsheet/spreadsheet.component";

@NgModule({
declarations: [AppComponent, SpreadsheetComponent],
imports: [BrowserModule],
providers: [],
bootstrap: [AppComponent],
})
export class AppModule {}

For correct rendering of fonts, open the angular.json file and complete the "assets" array in the following way (replace spreadsheet_package with the name of your local folder that contains Spreadsheet source files):

angular.json
...
"assets": [
"src/favicon.ico",
"src/assets",
{
"input": "./spreadsheet_package/codebase/fonts",
"glob": "**/*",
"output": "assets"
}
],
...

The last step is to open the src/main.ts file and replace the existing code with the following one:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

After that, when we start the app, we should see Spreadsheet loaded with data on a page.

Spreadsheet initialization

Now you should have a basic setup for integrating DHTMLX Spreadsheet with Angular using Angular CLI. You can customize the code according to your specific requirements.

Skip to main content

Integration with React

tip

You should be familiar with the basic concepts and patterns of React to use this documentation. If you are not, please refer to the React documentation for a getting-started tutorial.

DHTMLX Spreadsheet is compatible with React. We have prepared code examples of how to use DHTMLX Spreadsheet with React. To check online samples, please refer to the corresponding Example on Replit.

You can also check the demo on GitHub.

Creating a project

info

Before you start to create a new project, install Vite (optional) and Node.js.

You can create a basic React project or use React with Vite:

npx create-vite my-react-spreadsheet-app --template react

Installation of dependencies

Next you should go to the app directory. Let's call our project my-react-spreadsheet-app and run:

cd my-react-spreadsheet-app

After that you should install dependencies and start the dev server. For this, you need to make use of a package manager:

  • if you use yarn, you need to call the following commands:
yarn install
yarn dev
  • if you use npm, you need to call the following commands:
npm install
npm run dev

You should now have your React project running on http://localhost:5173.

React app running

Creating Spreadsheet

Now we should get the DHTMLX Spreadsheet code. First of all, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Spreadsheet package.

Step 1. Package installation

Download the trial Spreadsheet package and follow the steps mentioned in the README file. Note that the trial Spreadsheet is available 30 days only.

Check the How to Start guide to learn about the available installation ways.

Step 2. Component creation

Now we should create a React component, to add a Spreadsheet into the application. Let's create a new file in the src/ directory and name it Spreadsheet.jsx.

Importing source files

Open the file and import Spreadsheet source files. Note that:

  • if you've installed the Spreadsheet package from a local folder, your import paths will look like this:
Spreadsheet.jsx
import { Spreadsheet } from 'dhx-spreadsheet-package';
import 'dhx-spreadsheet-package/codebase/spreadsheet.css';

Note that depending on the used package, the source files can be minified. In this case make sure that you are importing the CSS file as spreadsheet.min.css.

note

In case you use npm with a local Spreadsheet package, the way of importing Spreadsheet source files is different. Check the details below

  • if you've chosen to install the trial version, the import paths should be as in:
Spreadsheet.jsx
import { Spreadsheet } from '@dhx/trial-spreadsheet';
import '@dhx/trial-spreadsheet/codebase/spreadsheet.min.css';

In this tutorial we will use the trial version of Spreadsheet.

Setting the container and adding Spreadsheet

To display Spreadsheet on the page, we need to set the container to render the component inside. Check the code below:

Spreadsheet.jsx
import { Spreadsheet } from '@dhx/trial-spreadsheet';
import '@dhx/trial-spreadsheet/codebase/spreadsheet.min.css';
import { useRef } from "react";

// eslint-disable-next-line react/prop-types
const SpreadsheetComponent = () => {
const node = useRef(null);

return (
<div
ref={node}
style={{width:"800px", height:"400px", margin:"50px"}}
></div>
);
};

export default SpreadsheetComponent;

Then we need to add our Spreadsheet into the container. To do that, import the useEffect() method of React and use it to render the Spreadsheet instance and destruct when it is no longer needed:

Spreadsheet.jsx
import { useEffect, useRef, useState } from "react";

// eslint-disable-next-line react/prop-types
const SpreadsheetComponent = () => {
const node = useRef(null);
let [spreadsheet, setSpreadsheet] = useState(null);

useEffect(() => {
const spreadsheet = new Spreadsheet(node.current, {});
setSpreadsheet(spreadsheet);
return () => spreadsheet.destructor();
}, []);

return (
<div
ref={node}
style={{width:"800px", height:"400px", margin:"50px"}}
></div>
);
};

export default SpreadsheetComponent;
note

In case you use npm with a local Spreadsheet package, the way of Spreadsheet initialization differs a little bit. Check the details below

Using npm with Spreadsheet package

If you use npm with a Spreadsheet package, the import of the source files and the initialization of Spreadsheet will differ from the common way:

  • include the Spreadsheet source files in the index.html file as shown in the example below. Replace spreadsheet_package with the name of your local folder that contains Spreadsheet source files:
index.html
<script src="./spreadsheet_package/codebase/spreadsheet.js"></script>
<link rel="stylesheet" href="./spreadsheet_package/codebase/spreadsheet.css">
  • use the dhx prefix to initialize Spreadsheet, check the example below:
Spreadsheet.jsx
useEffect(() => {
const spreadsheet = new dhx.Spreadsheet(node.current, {});
setSpreadsheet(spreadsheet);
return () => spreadsheet.destructor();
}, []);

Loading data

To add data into the Spreadsheet, we need to provide a data set. Let's create the data.js file in the src/ directory and add some data into it:

data.js
export function getData() {
return {
styles: {
bold: {
"font-weight": "bold",
},
right: {
"justify-content": "flex-end",
"text-align": "right",
},
},
data: [
{ cell: "a1", value: "Country", css:"bold" },
{ cell: "b1", value: "Product", css:"bold" },
{ cell: "c1", value: "Price", css:"right bold" },
{ cell: "d1", value: "Amount", css:"right bold" },
{ cell: "e1", value: "Total Price", css:"right bold" },

{ cell: "a2", value: "Ecuador" },
{ cell: "b2", value: "Banana" },
{ cell: "c2", value: 6.68, format: "currency" },
{ cell: "d2", value: 430 },
{ cell: "e2", value: 2872.4, format: "currency" },

{ cell: "a3", value: "Belarus" },
{ cell: "b3", value: "Apple" },
{ cell: "c3", value: 3.75, format: "currency" },
{ cell: "d3", value: 600 },
{ cell: "e3", value: 2250, format: "currency" },

{ cell: "a4", value: "Peru" },
{ cell: "b4", value: "Grapes" },
{ cell: "c4", value: 7.69, format: "currency" },
{ cell: "d4", value: 740 },
{ cell: "e4", value: 5690.6, format: "currency" },

// more cells with data
],
}
}

Then open the Spreadsheet.jsx file, pass the name of the data file to the component constructor function and use the parse() method inside the useEffect() method of React to load data into spreadsheet:

Spreadsheet.jsx
const SpreadsheetComponent = ({ data }) => {
const node = useRef(null);
let [spreadsheet, setSpreadsheet] = useState(null);

useEffect(() => {
const spreadsheet = new Spreadsheet(node.current, {});
setSpreadsheet(spreadsheet);
return () => spreadsheet.destructor();
}, []);

useEffect(() => {
if (data && spreadsheet) {
spreadsheet.parse(data);
}
}, [spreadsheet, data]);

return <div ref={node} ></div>;
};

The spreadsheet.parse(data); line will provide data reloading on each applied change.

Now the Spreadsheet component is ready. When the element will be added to the page, it will initialize the Spreadsheet object with data. You can provide necessary configuration settings as well. Visit our Spreadsheet API docs to check the full list of available properties.

Handling events

When a user makes some action in the Spreadsheet, it invokes an event. You can use these events to detect the action and run the desired code for it. See the full list of events.

Open Spreadsheet.jsx and complete the useEffect() method as in:

Spreadsheet.jsx
useEffect(() => {
const spreadsheet = new Spreadsheet(node.current, {});
setSpreadsheet(spreadsheet);

spreadsheet.events.on("ActionName", () => {});

return () => spreadsheet.destructor();
}, []);

Replace 'ActionName' with the actual event name you want to handle, and implement the corresponding code inside the callback function. Get more information about the work with events in the Event Handling article.

Step 3. Adding Spreadsheet into the app

Now it's time to add the component into our app. Open App.jsx and replace the default code with the following one:

App.jsx
import { useState } from "react";
import SpreadsheetComponent from "./SpreadsheetComponent";
import { getData } from "./data";

function App() {
let [data] = useState(getData());

return <SpreadsheetComponent data={data} />;
}

export default App;

After that, when we start the app, we should see Spreadsheet loaded with data on a page.

Spreadsheet initialization

Now you should have a basic setup for integrating DHTMLX Spreadsheet with React. You can customize the code according to your specific requirements.

Integration with Vue.js
You should be familiar with the basic concepts and patterns of Vue to use this documentation. If you are not, please refer to the Vue 3 documentation for a getting-started tutorial.
DHTMLX Spreadsheet is compatible with Vue. We have prepared code examples of how to use DHTMLX Spreadsheet with Vue. To check online samples, please refer to the corresponding Example on Replit.
You can also check the demo on GitHub.
Creating a project
Before you start to create a new project, install Node.js.
To create a Vue project, run the following command:
npm create vue@latest
This command will install and execute create-vue
, the official Vue project scaffolding tool. Check the details in the Vue.js Quick Start.
Installation of dependencies
Next you should go to the app directory. Let's name our project spreadsheet-vue and run:
cd spreadsheet-vue
After that you should install dependencies and start the dev server. For this, you need to make use of a package manager:
- if you use yarn, you need to call the following commands:
yarn install
yarn dev
- if you use npm, you need to call the following commands:
npm install
npm run dev
You should now have your Vue project running on http://localhost:5173
.
Creating Spreadsheet
Now we should get the DHTMLX Spreadsheet code. First of all, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Spreadsheet package.
Step 1. Package installation
Download the trial Spreadsheet package and follow the steps mentioned in the README file. Note that the trial Spreadsheet is available 30 days only.
Check the How to Start guide to learn about the available installation ways.
Step 2. Component creation
Now we should create a Vue component, to add a Spreadsheet into the application. Let's create a new file in the src/components/ directory and name it Spreadsheet.vue.
Importing source files
Open the file and import Spreadsheet source files. Note that:
- if you've installed the Spreadsheet package from a local folder, your import paths will look like this:
import { Spreadsheet } from 'dhx-spreadsheet-package';
import 'dhx-spreadsheet-package/codebase/spreadsheet.css';
Note that depending on the used package, the source files can be minified. In this case make sure that you are importing the CSS file as spreadsheet.min.css.
In case you use npm with a local Spreadsheet package, the way of importing Spreadsheet source files is different. Check the details below
- if you've chosen to install the trial version, the import paths should be as in:
import { Spreadsheet } from '@dhx/trial-spreadsheet';
import '@dhx/trial-spreadsheet/codebase/spreadsheet.min.css';
In this tutorial we will use the trial version of Spreadsheet.
Setting the container and adding Spreadsheet
To display Spreadsheet on the page, we need to set the container to render the component inside. Check the code below:
<script>
import { Spreadsheet } from "@dhx/trial-spreadsheet";
import "@dhx/trial-spreadsheet/codebase/spreadsheet.min.css";
</script>
<template>
<div ref="container" style="width: 100%; height: 80vh; "></div>
</template>
Then we need to render our Spreadsheet in the container. Use the new Spreadsheet()
constructor inside the mounted()
method of Vue.js to initialize Spreadsheet inside of the container that you've set above:
<script>
export default {
mounted: function() {
this.spreadsheet = new Spreadsheet(this.$refs.container, {});
}
};
</script>
<template>
<div ref="container" style="width: 100%; height: 80vh; "></div>
</template>
In case you use npm with a local Spreadsheet package, the way of Spreadsheet initialization differs a little bit. Check the details below
To clear the component as it has unmounted, use the spreadsheet.destructor()
call and remove the container after that inside the unmounted()
method of Vue.js, as follows:
<script>
export default {
mounted: function() {
this.spreadsheet = new Spreadsheet(this.$refs.container, {});
},
unmounted() {
this.spreadsheet.destructor();
this.$refs.container.innerHTML = "";
},
}
</script>
<template>
<div ref="container" style="width: 100%; height: 80vh; "></div>
</template>
Using npm with Spreadsheet package
If you use npm with a Spreadsheet package, the import of the source files and the initialization of Spreadsheet will differ from the common way:
- include the Spreadsheet source files in the index.html file as shown in the example below. Replace spreadsheet_package with the name of your local folder that contains Spreadsheet source files:
<script src="./spreadsheet_package/codebase/spreadsheet.js"></script>
<link rel="stylesheet" href="./spreadsheet_package/codebase/spreadsheet.css">
- use the dhx prefix to initialize Spreadsheet, check the example below:
<script>
export default {
mounted: function() {
this.spreadsheet = new dhx.Spreadsheet(this.$refs.container, {});
}
};
</script>
Loading data
Next you can load data into the Spreadsheet. For this, you need to provide a data set. Create the data.js file in the src/ directory and add some data into it:
export function getData() {
return {
styles: {
bold: {
"font-weight": "bold",
},
right: {
"justify-content": "flex-end",
"text-align": "right",
},
},
data: [
{ cell: "a1", value: "Country", css:"bold" },
{ cell: "b1", value: "Product", css:"bold" },
{ cell: "c1", value: "Price", css:"right bold" },
{ cell: "d1", value: "Amount", css:"right bold" },
{ cell: "e1", value: "Total Price", css:"right bold" },
{ cell: "a2", value: "Ecuador" },
{ cell: "b2", value: "Banana" },
{ cell: "c2", value: 6.68, format: "currency" },
{ cell: "d2", value: 430 },
{ cell: "e2", value: 2872.4, format: "currency" },
{ cell: "a3", value: "Belarus" },
{ cell: "b3", value: "Apple" },
{ cell: "c3", value: 3.75, format: "currency" },
{ cell: "d3", value: 600 },
{ cell: "e3", value: 2250, format: "currency" },
{ cell: "a4", value: "Peru" },
{ cell: "b4", value: "Grapes" },
{ cell: "c4", value: 7.69, format: "currency" },
{ cell: "d4", value: 740 },
{ cell: "e4", value: 5690.6, format: "currency" },
// more cells with data
],
}
}
Then open the Spreadsheet.vue file and use the spreadsheet.parse()
method to load data. It will reload data on each applied change:
<script>
export default {
mounted: function() {
this.spreadsheet = new Spreadsheet(this.$refs.container, {});
this.spreadsheet.parse(data);
}
}
</script>
Now the Spreadsheet component is ready. When the element will be added to the page, it will initialize the Spreadsheet object with data. You can provide necessary configuration settings as well. Visit our Spreadsheet API docs to check the full list of available properties.
Handling events
When a user makes some action in the Spreadsheet, it invokes an event. You can use these events to detect the action and run the desired code for it. See the full list of events.
Open Spreadsheet.vue and complete the mounted()
method:
<script>
export default {
mounted: function() {
this.spreadsheet = new Spreadsheet(this.$refs.container, {});
this.spreadsheet.events.on("ActionName", () => {do something});
}
}
</script>
Replace 'ActionName'
with the actual event name you want to handle, and implement the corresponding code inside the callback function. Get more information about the work with events in the Event Handling article.
Step 3. Adding Spreadsheet into the app
Now it's time to add the component into our app. Open App.vue and replace the code with the following one:
<script>
import Spreadsheet from "./components/Spreadsheet.vue";
import { getData } from "./data";
export default {
components: { Spreadsheet },
data() {
return { data: getData() };
},
};
</script>
<template>
<Spreadsheet :data="data" />
</template>
After that, when we start the app, we should see Spreadsheet loaded with data on a page.
Now you should have a basic setup for integrating DHTMLX Spreadsheet with Vue.js. You can customize the code according to your specific requirements.

Skip to main content

Integration with Svelte

tip

You should be familiar with the basic concepts and patterns of Svelte to use this documentation. If you are not, please refer to the Svelte documentation for a getting-started tutorial.

DHTMLX Spreadsheet is compatible with Svelte. We have prepared code examples of how to use DHTMLX Spreadsheet with Svelte. To check online samples, please refer to the corresponding Example on Replit.

You can also check the demo on GitHub.

Creating a project

info

Before you start to create a new project, install Vite (optional) and Node.js.

There are several ways of creating a project:

or

  • you can also use Svelte with Vite (but without SvelteKit):
npm create vite@latest

Check the details in the related article.

Installation of dependencies

Independent of the chosen way, next you should go to the app directory. Let's call our project spreadsheet-svelte and run:

cd spreadsheet-svelte

Then you need to install dependencies and run the app. For this, you need to make use of a package manager:

  • if you use yarn, you need to call the following commands:
yarn install
yarn dev
  • if you use npm, you need to call the following commands:
npm install
npm run dev

After the above steps are complete, the app should run on http://localhost:5173.

Svelte app running

Creating Spreadsheet

Now we should get the DHTMLX Spreadsheet code. First of all, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Spreadsheet package.

Step 1. Package installation

Download the trial Spreadsheet package and follow the steps mentioned in the README file. Note that the trial Spreadsheet is available 30 days only.

Check the How to Start guide to learn about the available installation ways.

Step 2. Component creation

Now we should create a Svelte component, to add a Spreadsheet into the application. Let's create a new file in the src/ directory and name it Spreadsheet.svelte.

Importing source files

Open the file and import Spreadsheet source files. Note that:

  • if you've installed the Spreadsheet package from a local folder, your import paths will look like this:
Spreadsheet.svelte
import { Spreadsheet } from 'dhx-spreadsheet-package';
import 'dhx-spreadsheet-package/codebase/spreadsheet.css';

Note that depending on the used package, the source files can be minified. In this case make sure that you are importing the CSS file as spreadsheet.min.css.

note

In case you use npm with a local Spreadsheet package, the way of importing Spreadsheet source files is different. Check the details below

  • if you've chosen to install the trial version, the import paths should be as in:
Spreadsheet.svelte
import { Spreadsheet } from '@dhx/trial-spreadsheet';
import '@dhx/trial-spreadsheet/codebase/spreadsheet.min.css';

In this tutorial we will use the trial version of Spreadsheet.

Setting the container and adding Spreadsheet

To display Spreadsheet on the page, we need to set the container to render the component inside. Check the code below:

Spreadsheet.svelte
<script>
import { Spreadsheet } from "@dhx/trial-spreadsheet";
import "@dhx/trial-spreadsheet/codebase/spreadsheet.min.css"

let container;
</script>

<div bind:this={container} class="container"></div>

<style>
.container {
width: 100%;
height: 400px;
}
</style>

Then we need to render our Spreadsheet in the container. To do that, use the onMount() method of Svelte. Inside the method you can also specify the destructor() method to remove the Spreadsheet instance, when it is no longer needed:

Spreadsheet.svelte
<script>
import { Spreadsheet } from "@dhx/trial-spreadsheet";
import "@dhx/trial-spreadsheet/codebase/spreadsheet.min.css";
import { onMount } from "svelte";

let spreadsheet;
let container;

onMount(() => {
spreadsheet = new Spreadsheet(container,{});
return () => spreadsheet.destructor();
});

</script>

<div bind:this={container} class="container"></div>
note

In case you use npm with a local Spreadsheet package, the way of Spreadsheet initialization differs a little bit. Check the details below

Using npm with Spreadsheet package

If you use npm with a Spreadsheet package, the import of the source files and the initialization of Spreadsheet will differ from the common way:

  • include the Spreadsheet source files in the index.html file as shown in the example below. Replace spreadsheet_package with the name of your local folder that contains Spreadsheet source files:
index.html
<script src="./spreadsheet_package/codebase/spreadsheet.js"></script>
<link rel="stylesheet" href="./spreadsheet_package/codebase/spreadsheet.css">
  • use the dhx prefix to initialize Spreadsheet, check the example below:
Spreadsheet.svelte
<script>
onMount(() => {
spreadsheet = new dhx.Spreadsheet(container,{});
});
</script>

Loading data

To add data into the Spreadsheet, we need to provide a data set. Let's create the data.js file in the src/ directory and add some data into it:

data.js
export function getData() {
return {
styles: {
bold: {
"font-weight": "bold",
},
right: {
"justify-content": "flex-end",
"text-align": "right",
},
},
data: [
{ cell: "a1", value: "Country", css:"bold" },
{ cell: "b1", value: "Product", css:"bold" },
{ cell: "c1", value: "Price", css:"right bold" },
{ cell: "d1", value: "Amount", css:"right bold" },
{ cell: "e1", value: "Total Price", css:"right bold" },

{ cell: "a2", value: "Ecuador" },
{ cell: "b2", value: "Banana" },
{ cell: "c2", value: 6.68, format: "currency" },
{ cell: "d2", value: 430 },
{ cell: "e2", value: 2872.4, format: "currency" },

{ cell: "a3", value: "Belarus" },
{ cell: "b3", value: "Apple" },
{ cell: "c3", value: 3.75, format: "currency" },
{ cell: "d3", value: 600 },
{ cell: "e3", value: 2250, format: "currency" },

{ cell: "a4", value: "Peru" },
{ cell: "b4", value: "Grapes" },
{ cell: "c4", value: 7.69, format: "currency" },
{ cell: "d4", value: 740 },
{ cell: "e4", value: 5690.6, format: "currency" },

// more cells with data
],
}
}

Then open the Spreadsheet.svelte file, specify the line for data export and use the parse() method to load data:

Spreadsheet.svelte
<script>
import { Spreadsheet } from "@dhx/trial-spreadsheet";
import "@dhx/trial-spreadsheet/codebase/spreadsheet.min.css";
import { onMount } from "svelte";

export let data;

let spreadsheet;
let container;

onMount(() => {
spreadsheet = new Spreadsheet(container, {});
spreadsheet.events.on("ActionName", () => {})
});

$: spreadsheet?.parse(data);
</script>

<div bind:this={container}></div>

The $: spreadsheet?.parse(data); line will provide data reloading on each applied change.

Now the Spreadsheet component is ready. When the element will be added to the page, it will initialize the Spreadsheet object with data. You can provide necessary configuration settings as well. Visit our Spreadsheet API docs to check the full list of available properties.

Handling events

When a user makes some action in the Spreadsheet, it invokes an event. You can use these events to detect the action and run the desired code for it. See the full list of events.

Open Spreadsheet.svelte and complete the onMount() method as in:

Spreadsheet.svelte
onMount(() => {
spreadsheet = new Spreadsheet(container, {});
spreadsheet.events.on("ActionName", () => {do something});
});

Replace 'ActionName' with the actual name of the event you want to handle, and implement the corresponding code inside the callback function. Get more information about the work with events in the Event Handling article.

Step 3. Adding Spreadsheet into the app

Now it's time to add the component into our app. Open App.svelte and replace the default code with the following one:

App.svelte
<script>
import Spreadsheet from "./Spreadsheet.svelte";
import { getData } from "./data.js";
</script>

<Spreadsheet data={getData()} />

After that, when we start the app, we should see Spreadsheet loaded with data on a page.

Spreadsheet initialization

Now you should have a basic setup for integrating DHTMLX Spreadsheet with Svelte. You can customize the code according to your specific requirements.